ECHO OFF
COLOR 2
mode con: cols=160 lines=30

if exist "%cd%\Backup\" ( 
  for /f "skip=5 tokens=1,2,4 delims= " %%a in (
   'dir /ad /tc "%cd%\Backup\."') do IF "%%c"=="." (
    set "dt=%%a"
    set backup=Backup created on: %%a, %%b
  )
) else ( 
  set backup=No backup found
)

if exist "%cd%\Install\path.txt" ( 
set /p apb=< Install\path.txt
goto MENU
  )
) else ( 
goto start
)

:START
Echo These are your current drives.
Echo -----------------------------
wmic logicaldisk get caption,volumename
Echo -----------------------------
set /p Input=What drive is APB installed on (Leave blank for manual path): 

IF "%Input%"=="" (GOTO PATH) ELSE (GOTO FIND)

:FIND
cls
echo Hold on while we look for your APB folder. This might take a few minutes depending on your drive size.
for /d /r "%Input%:\" %%i in ("APB Reloaded") do @if exist "%%i" set apb=%%i
set apb=%apb:"=%
cls
echo We found an APB folder in the following direcotry: %apb%

SET /P AREYOUSURE=Is this the correct path to your APB folder? (Y/[N]): 
IF /I "%AREYOUSURE%" NEQ "Y" GOTO PATH
@echo %APB%> Install\path.txt
cls

:MENU
COLOR 2
cls
SET M==""
ECHO -v1.09---------------------------------
ECHO Please select one of the options below.
ECHO ---------------------------------------
ECHO A - Install Everything
ECHO B - Create/Restore backup - [%backup%]
ECHO 1 - Set/correct APB path. - [%apb%]
ECHO 2 - Install Last Stage Names - [%lsn%]
ECHO 3 - Install Login Screen Fix (3 versions) - [%lsf%]
ECHO 4 - Install Low Quality Config - [%lqc%]
ECHO 5 - Install No Muzzle Flash - [%nmf%]
ECHO 6 - Install Ambient Sound Removal - [%asr%]
ECHO 7 - Install Blood removal fix - [%brf%]
ECHO 8 - Install Effects Particle fix (No explosions, car fire, car explosions and more) - [%epf%]
ECHO 9 - Install Sprint + Crouch fix - [%scf%]
ECHO M - Install Misc Fixes (disable videos, remove music, disable vivox.exe) - [%mf%]
ECHO S - Install shaders (Includes settings file) - [%SHADERS%]
ECHO Q - EXIT
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO MENU) ELSE (GOTO MENU_LIST)

:MENU_LIST
IF %M%==1 GOTO MENU_CHECK
IF %M%==2 GOTO LSN
IF %M%==3 GOTO LSF_PROMPT
IF %M%==4 GOTO LQC
IF %M%==5 GOTO NMF
IF %M%==6 GOTO ASR
IF %M%==7 GOTO BRF
IF %M%==8 GOTO EPF
IF %M%==9 GOTO SCF
IF %M%==M GOTO MF
IF %M%==Q GOTO EXIT
IF %M%==A GOTO ALL
IF %M%==S GOTO SHADERS
IF %M%==m GOTO MF
IF %M%==q GOTO EXIT
IF %M%==a GOTO ALL
IF %M%==s GOTO SHADERS
IF %M%==b GOTO BACKUP_PROMPT
IF %M%==B GOTO BACKUP_PROMPT

:MENU_CHECK
IF /I "%M%" NEQ "1" GOTO MENU

:PATH
cls
echo Please copy your APB path and paste it here. (E.g. G:\Program Files (x86)\Steam\steamapps\common\APB Reloaded)
set /p apb=APB folder path: 
del /q "%cd%\Install\path.txt"
@echo %APB%> Install\path.txt
cls
GOTO MENU

:LSN
xcopy /s /y "install\Icon_file.ico" "%apb%\Binaries\."
xcopy /s /y "install/Last_stage_names" "%apb%"
cls

set MYPATH=%apb%
set SCRIPT="%TEMP%\%RANDOM%-%RANDOM%-%RANDOM%-%RANDOM%.vbs"
echo Set oWS = WScript.CreateObject("WScript.Shell") >> %SCRIPT%
echo sLinkFile = "%USERPROFILE%\Desktop\APB - Mission Names.lnk" >> %SCRIPT%
echo Set oLink = oWS.CreateShortcut(sLinkFile) >> %SCRIPT%
echo oLink.TargetPath = "%mypath%/Binaries/APB.exe" >> %SCRIPT%
echo oLink.Arguments = "-language=1031" >> %SCRIPT%
echo oLink.IconLocation = "%mypath%\Binaries\Icon_file.ico" >> %SCRIPT%
echo olink.WorkingDirectory = "%mypath%/Binaries/" >> %SCRIPT%
echo oLink.Save >> %SCRIPT%
cscript /nologo %SCRIPT%
del %SCRIPT%

set lsn=Installed and shortcut added to desktop
goto MENU

:LSF_PROMPT
cls
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the options below.
ECHO ---------------------------------------
ECHO 1 - Grey
ECHO 2 - Simple (Will allow new character creation)
ECHO 3 - Black
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO LSF_PROMPT) ELSE (GOTO LSF_LIST)

:LSF_LIST
IF %M%==1 GOTO LSF1
IF %M%==2 GOTO LSF2
IF %M%==3 GOTO LSF3
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO LSF_PROMPT
cls

:LSF1
xcopy /s /y "install/Login_screen_fix1" "%apb%"
cls
set lsf=Installed
goto MENU

:LSF2
xcopy /s /y "install/Login_screen_fix2" "%apb%"
cls
set lsf=Installed
goto MENU

:LSF3
xcopy /s /y "install/Login_screen_fix3" "%apb%"
cls
set lsf=Installed
goto MENU

:LQC
xcopy /s /y "install/Low_quality_config" "%apb%"
cls
set lqc=Installed
goto MENU

:NMF
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Weapon.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Weapon_Tracers.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_WeaponCommon.upk"
cls
set nmf=Installed
goto MENU

:ASR
xcopy /s /y "install/Remove_ambient_sound" "%apb%"
cls
set asr=Installed
goto MENU

:BRF
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Character\VFX_Character.upk"
cls
set brf=Installed
goto MENU

:EPF
xcopy /s /y "install/remove_effects_particles" "%apb%"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Vehicle\VFX_Vehicle.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Explosions.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\vfx_common_fxville.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Checkpoints.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Common_ReUsable.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_CommonMaterial.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Mission_Task.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_TexturesArchive.upk"

cls
set epf=Installed
goto MENU

:SCF
xcopy /s /y "install/sprint_crouch_fix" "%apb%"
cls
set scf=Installed
goto MENU

:MF
xcopy /s /y "install/misc_fixes" "%apb%"
del /q "%apb%\APBGame\Movies\*"
cls
set mf=Installed
goto MENU

:SHADERS
xcopy /s /y "install/Shaders" "%apb%"
cls
start notepad "%apb%\Engine\Shaders\Settings.usf"
ECHO -----------------------------------------
ECHO Shaders settings info is provided below.
ECHO -----------------------------------------
ECHO SET_FOG - 0 will remove distance fog. (0 by default)
ECHO SET_BLOOM - 0 will remove bloom. (0 by default)
ECHO SET_COLORGRADING - 0 will remove the blue tint color grading. (0 by default)
ECHO SET_CROSSHAIR - 1 will enable the crosshair shader. Additional changes have to be done in the CrosshairSettings.usf file. (1 by default)
ECHO SET_OUTLINE - 1 will enable the outline shader. Additional changes have to be done in the OutlinePixelShaderSettings.usf file. (0 by default)
ECHO.
ECHO Press any key when you've made changes to the settings file.
set SHADERS=Installed
pause >nul
GOTO MENU

:ALL
xcopy /s /y "install\Icon_file.ico" "%apb%\Binaries\."
xcopy /s /y "install/Last_stage_names" "%apb%"
set MYPATH=%apb%
set SCRIPT="%TEMP%\%RANDOM%-%RANDOM%-%RANDOM%-%RANDOM%.vbs"
echo Set oWS = WScript.CreateObject("WScript.Shell") >> %SCRIPT%
echo sLinkFile = "%USERPROFILE%\Desktop\APB - Mission Names.lnk" >> %SCRIPT%
echo Set oLink = oWS.CreateShortcut(sLinkFile) >> %SCRIPT%
echo oLink.TargetPath = "%mypath%/Binaries/APB.exe" >> %SCRIPT%
echo oLink.Arguments = "-language=1031" >> %SCRIPT%
echo oLink.IconLocation = "%mypath%\Binaries\Icon_file.ico" >> %SCRIPT%
echo olink.WorkingDirectory = "%mypath%/Binaries/" >> %SCRIPT%
echo oLink.Save >> %SCRIPT%
cscript /nologo %SCRIPT%
del %SCRIPT%
set lsn=Installed and shortcut added to desktop
xcopy /s /y "install/Login_screen_fix3" "%apb%"
set lsf=Installed
xcopy /s /y "install/Low_quality_config" "%apb%"
set lqc=Installed
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Weapon.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Weapon_Tracers.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_WeaponCommon.upk"
set nmf=Installed
xcopy /s /y "install/Remove_ambient_sound" "%apb%"
set asr=Installed
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Character\VFX_Character.upk"
set brf=Installed
xcopy /s /y "install/remove_effects_particles" "%apb%"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Vehicle\VFX_Vehicle.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Weapon\VFX_Explosions.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\vfx_common_fxville.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Checkpoints.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Common_ReUsable.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_CommonMaterial.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_Mission_Task.upk"
del /q "%apb%\APBGame\Content\Release\Packages\VFX\Common\VFX_TexturesArchive.upk"
set epf=Installed
xcopy /s /y "install/sprint_crouch_fix" "%apb%"
set scf=Installed
xcopy /s /y "install/misc_fixes" "%apb%"
del /q "%apb%\APBGame\Movies\*"
set mf=Installed
xcopy /s /y "install/Shaders" "%apb%"
cls
start notepad "%apb%\Engine\Shaders\Settings.usf"
ECHO -----------------------------------------
ECHO Shaders settings info is provided below.
ECHO -----------------------------------------
ECHO SET_FOG - 0 will remove distance fog. (0 by default)
ECHO SET_BLOOM - 0 will remove bloom. (0 by default)
ECHO SET_COLORGRADING - 0 will remove the blue tint color grading. (0 by default)
ECHO SET_CROSSHAIR - 1 will enable the crosshair shader. Additional changes have to be done in the CrosshairSettings.usf file. (1 by default)
ECHO SET_OUTLINE - 1 will enable the outline shader. Additional changes have to be done in the OutlinePixelShaderSettings.usf file. (0 by default)
ECHO.
ECHO Press any key when you've made changes to the settings file.
set SHADERS=Installed
pause >nul
GOTO MENU

:BACKUP_PROMPT
cls
tasklist /fi "imagename eq APB.exe" |find ":" > nul
if errorlevel 1 (
COLOR 46
ECHO ---------------------------------------
ECHO NOTE THAT APB.EXE IS RUNNING!
ECHO THIS COULD BREAK THE BACKUP/RESTORE PROCESS!
ECHO CLOSE THE PROCESS BEFORE CONTINUING!
ECHO ---------------------------------------
TaskMgr
tasklist /fi "imagename eq APB.exe" |find ":" > nul
if errorlevel 1 (
GOTO MENU
)
) else (
tasklist /fi "imagename eq APB_BE.exe" |find ":" > nul
if errorlevel 1 (
COLOR 46
ECHO ---------------------------------------
ECHO NOTE THAT APB_BE.EXE IS RUNNING!
ECHO THIS COULD BREAK THE BACKUP/RESTORE PROCESS!
ECHO CLOSE THE PROCESS BEFORE CONTINUING!
ECHO ---------------------------------------
TaskMgr
tasklist /fi "imagename eq APB_BE.exe" |find ":" > nul
if errorlevel 1 (
GOTO MENU
)
)
)
COLOR 2
SET M==""
ECHO ---------------------------------------
ECHO Please select one of the options below.
ECHO ---------------------------------------
ECHO %backup%
ECHO.
ECHO B - Backup
ECHO R - Restore
ECHO M - Go back to the menu
ECHO ---------------------------------------
SET /P M=Select what to do and press ENTER: 

IF "%M%"=="" (GOTO BACKUP_PROMPT) ELSE (GOTO BACKUP_LIST)

:BACKUP_LIST
IF %M%==B GOTO BACKUP
IF %M%==b GOTO BACKUP
IF %M%==R GOTO RESTORE
IF %M%==r GOTO RESTORE
IF %M%==m GOTO MENU
IF %M%==M GOTO MENU
GOTO BACKUP_PROMPT
cls

:BACKUP
if not exist "%cd%\Backup\" mkdir "Backup"
if exist "%cd%\Backup\" RD /S /Q "Backup"
if not exist "%cd%\Backup\" mkdir "Backup"
del /q "%apb%\APBGame\Content\Audio\FilePackages\Dialogue_Russian.pck"
xcopy /s /y /i "%apb%\APBGame\Content\Release\Maps\APBLoginLevel.apb" "%cd%\Backup\APBGame\Content\Release\Maps\*"
xcopy /s /y /i "%apb%\APBGame\Content\Release\Packages\VFX" "%cd%\Backup\APBGame\Content\Release\Packages\VFX"
xcopy /s /y /i "%apb%\APBGame\Localization\GER" "%cd%\Backup\APBGame\Localization\GER"
xcopy /s /y /i "%apb%\APBGame\Config" "%cd%\Backup\APBGame\Config"
xcopy /s /y /i "%apb%\APBGame\Content\Audio" "%cd%\Backup\APBGame\Content\Audio"
xcopy /s /y /i "%apb%\APBGame\Movies" "%cd%\Backup\APBGame\Movies"
xcopy /s /y /i "%apb%\Binaries" "%cd%\Backup\Binaries"
xcopy /s /y /i "%apb%\Engine\Shaders" "%cd%\Backup\Engine\Shaders"

if exist "%cd%\Backup\" ( 
  for /f "skip=5 tokens=1,2,4 delims= " %%a in (
   'dir /ad /tc "%cd%\Backup\."') do IF "%%c"=="." (
    set "dt=%%a"
    set backup=Backup created on: %%a, %%b
  )
) else ( 
  set backup=No backup found
)

GOTO MENU

:RESTORE
if not exist "%cd%\Backup\" goto BACKUP_PROMPT
del /q "%apb%\Engine\Shaders\*.*"
xcopy /s /y /i "%cd%\Backup\*" "%apb%"
GOTO MENU

:EXIT
exit